<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Controller\Adminhtml\Job;

class MassSchedule extends MassAbstract
{
    /**
     *
     * @var \Neklo\Scheduler\Model\ScheduleFactory
     */
    protected $scheduleFactory;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Registry $registry,
        \Neklo\Scheduler\Model\JobFactory $modelFactory,
        \Neklo\Scheduler\Model\ScheduleFactory $scheduleFactory,
        \Psr\Log\LoggerInterface $logger
    ) {
        $this->scheduleFactory = $scheduleFactory;
        parent::__construct(
            $context,
            $resultPageFactory,
            $registry,
            $modelFactory,
            $logger
        );
    }

    protected function itemOperation(\Neklo\Scheduler\Model\Job $item)
    {
        $this->scheduleFactory->create()
            ->initializeFromJob($item)
            ->setJob($item)
            ->setScheduledReason("Scheduled From Admin")
            ->schedule()
            ->save();

        $this->messageManager->addSuccess(__('Job "%1" has been scheduled.', $item->getName()));
        return $item;
    }
}
