<?php
/*
NOTICE OF LICENSE

This source file is subject to the NekloEULA that is bundled with this package in the file ICENSE.txt.

It is also available through the world-wide-web at this URL: http://store.neklo.com/LICENSE.txt

Copyright (c)  Neklo (http://store.neklo.com/)
*/


namespace Neklo\Scheduler\Observer;

use Magento\Framework\App\State;
use Magento\Framework\Console\Cli;
use Magento\Cron\Model\Schedule;
use Neklo\Scheduler\Api\Data\JobInterface;

class ProcessCronQueueObserver extends \Magento\Cron\Observer\ProcessCronQueueObserver
{
    /**
     * Process cron queue
     * Generate tasks schedule
     * Cleanup tasks schedule
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     * @SuppressWarnings(PHPMD.CyclomaticComplexity)
     * @SuppressWarnings(PHPMD.NPathComplexity)
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        parent::execute($observer);

        $this->updateJobs();
    }

    private function updateJobs()
    {
        /** @var \Neklo\Scheduler\Model\JobFactory $jobGroups */

        $jobGroups = $this->_config->getJobs();
        foreach ($jobGroups as $group => $jobs) {
            foreach ($jobs as $jobName => $job) {
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $model = $objectManager->create('\Neklo\Scheduler\Model\Job');
                $model = $model->load($jobName, JobInterface::JOB_NAME);
                if (!$model->getId()) {
                    $model->setName($jobName)
                        ->setMethod($job[JobInterface::JOB_METHOD])
                        ->setInstance($job[JobInterface::JOB_CLASS])
                        ->setEnabled(true)
                        ->setGroup($group);
                    if (isset($job[JobInterface::JOB_SCHEDULE])) {
                        $model->setSchedule($job[JobInterface::JOB_SCHEDULE]);
                    }

                    if (isset($job[JobInterface::JOB_CONFIG])) {
                        $model->setConfigPath($job[JobInterface::JOB_CONFIG]);
                    }

                    $model->save();
                }
            }
        }
    }
}
